love.graphics.setCaption("LÖVE BURGERS - josefnpat - missingsentinelsoftware.com")

player = {}
player.img = love.graphics.newImage("nyu.png")

player.x = love.graphics.getWidth()/2
player.y = love.graphics.getHeight()/2

player.score = 0
player.maxscore = 0
dude = love.graphics.newImage("dude.png")
food = {}
food.list = {}
food.img = love.graphics.newImage("burger.png")

food.dt = 0
food.new_dt = 0.2
food.lifespan = 1

love.graphics.setBackgroundColor(200,221,118)

colors = {}
colors.fade = {255,255,255,127}
colors.reset = {255,255,255}

fonts = {}
fonts.base = love.graphics.newFont("HoltwoodOneSC.ttf",64)

love.graphics.setFont(fonts.base)

time = 10
ready = 3

readytab = {}
readytab[1] = {}
readytab[1].text = "Go!"
readytab[2] = {}
readytab[2].text = "Set!"
readytab[3] = {}
readytab[3].text = "Ready!"

function drawdude(x)
  love.graphics.draw(dude,(x-1)*32,0)
end

function love.draw()
  love.graphics.draw(player.img,player.x,player.y,0,1,1,32,32)
  for i,v in pairs(food.list) do
    love.graphics.draw(food.img,v.x,v.y,v.life,1,1,32,32)
  end

  if ready <= 0 then
    if player.score > player.maxscore then
      for i = 1,player.score do
        drawdude(i)
      end
    else
      love.graphics.setColor(colors.reset)
      for i = 1,player.score do
        drawdude(i)
      end
      love.graphics.setColor(colors.fade)
      for i = player.score,player.maxscore do
        drawdude(i)
      end
    end
  end

  love.graphics.setColor(colors.reset)

  if ready > 0 then
    local ind = math.floor(ready)+1
    if ind > 3 then ind = 3 end
    love.graphics.printf(readytab[ind].text,0,love.graphics.getHeight()/2-32,love.graphics.getWidth(),"center")
  else
    love.graphics.printf(round(time,1),0,0,love.graphics.getWidth(),"center")
  end
end

function love.update(dt)
  if ready > 0 then
    ready = ready - dt
  else
    ready = 0
    time = time - dt
  end
  if time < 0 then
    time = 10
    ready = 3
    if player.score > player.maxscore then
      player.maxscore = player.score
    end
    player.score = 0
    food.list = {}
  end
  if ready <= 0 then
    food.dt = food.dt + dt
    if food.dt >  food.new_dt then
      food.dt = food.dt - food.new_dt
      local theburgler = {}
      local padding = 64
      theburgler.x = math.random(padding,love.graphics.getWidth()-padding)
      theburgler.y = math.random(padding,love.graphics.getHeight()-padding)
      theburgler.life = 0
      table.insert(food.list,theburgler)
    end
  end

  local diffx = love.mouse.getX() - player.x
  local diffy = love.mouse.getY() - player.y

  local lerp = 16

  player.x = player.x + diffx/lerp
  player.y = player.y + diffy/lerp

  for i,v in pairs(food.list) do
    if dist(v.x,v.y,player.x,player.y) < 32 then
      player.score = player.score + 1
      v._remove = true
    end
    v.life =v.life + dt
    if v.life > food.lifespan then
      v._remove = true
    end
  end

  for i,v in pairs(food.list) do
    if v._remove then
      table.remove(food.list,i)
    end
  end

end

function dist(x1,y1,x2,y2)
  return math.sqrt( (x1-x2)^2 + (y1-y2)^2 )
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end
